unit BackupScene;

interface
uses
  Windows,eXgine,Scene,OpenGL,ASDVector,QuickSprites,GameMouse;
type
  TBackupScene=class(TScene)
  public
    SceneText:String;
    constructor Init;
    procedure Render; override;
    procedure Update; override;
  end;

implementation
uses
  Global,Tools,GameRender,TextSystem;
{ TBackupScene }

constructor TBackupScene.Init;
begin
  Create('Backup Scene');
  SceneText:='Game over';
end;

procedure TBackupScene.Render;
const
  NG='^2New Game = ^3F1';
  RL='^2Reload Map = ^3F2';
  NM='^2Next Map = ^3F3';
  EX='^2Quit = ^3Esc';
var
  W,H:Integer;
  procedure PrintC(Font:TFont; Y:Real; msg:string);
  begin
    DrawTextQ3(Font,(wnd.Width-TextQ3Len(0,msg))/2,Y-16,msg);
  end;
begin
  //ogl.Set2D(0,0,wnd.Width,wnd.Height); ogl.Clear;
  W:=wnd.Width; H:=wnd.Height;
  GSys.Render; ogl.Blend(BT_SUB);
  glColor4d(0.3,0.25,0.4,0.94);
  DrawRect(W/2-200,H/2-50,400,200);
  PrintC(Fnt[0],H/2,SceneText);
  PrintC(0,H/2+50,NG);
  PrintC(0,H/2+70,RL);
  PrintC(0,H/2+90,NM);
  PrintC(0,H/2+110,EX);
end;

procedure TBackupScene.Update;
begin
  UpdateMouse;
  if inp.Down(27) then ex.Quit;
  if inp.Down(VK_F1) then GSys.NewGame;
  if inp.Down(VK_F2) then GSys.ReloadMap;
  if inp.Down(VK_F3) then GSys.LoadNextMap;
end;

end.

