unit Global;
{<|Author : Adler3D|>}
{<|e-mail : Adler3D@mail.ru|>}
{<|site : Adler3D.narod.ru|>}
interface
uses
  eXgine,Scene,GameScene,BackupScene;
type
  TAppSettings=record
    Concurs:string;
    Name:string;
    Ver:string;
    Author:string;
    AASamples:Byte;
    UPS:Byte;
    Debug:Boolean;
    VSync:Boolean;
    IsRun:Boolean;
  end;
const
  ImgPath='Texture\';
  ImgPartPath=ImgPath+'Part\';
var
  App:TAppSettings;
  GSys:TGameScene;
  GBac:TBackupScene;
  Img:array [0..100] of TTexture;
  Fnt:array [0..20] of TFont;
  Wav:array [0..10] of TSound;

procedure InitApp;
procedure FreeApp;
implementation
uses GameMouse;

procedure InitApp;
begin
  {-=Init Mouse=-}
  InitMouse(wnd.Width/2,wnd.Height/2);
  {-=Init Sound=-}
  Wav[0]:=snd.Load(PChar('Dead.wav'));
  Wav[1]:=snd.Load(PChar('Fire.wav'));
  Wav[2]:=snd.Load(PChar('Grab.wav'));
  Wav[3]:=snd.Load(PChar('Load.wav'));
  Wav[4]:=snd.Load(PChar('Bum.wav'));
  Wav[5]:=snd.Load(PChar('Error.wav'));
  Wav[6]:=snd.Load(PChar('BulletOff.wav'));
  Wav[7]:=snd.Load(PChar('Win.wav'));
  //snd.Volume(50);
  {-=Load Image=-}
  Img[0]:=tex.Load(PChar('Cursor.tga'));
  Img[1]:=tex.Load(PChar('quad.tga'));
  Img[2]:=tex.Load(PChar('Award.tga'));
  Img[3]:=tex.Load(PChar('Circle.tga'));
  Img[4]:=tex.Load(PChar('Hint.tga'));
  Img[5]:=tex.Load(PChar('Rocket.tga'));
  Img[6]:=tex.Load(PChar('Tower.tga'));
  Img[7]:=tex.Load(PChar('Bazooka.tga'));
  Img[8]:=tex.Load(PChar('Dual.tga'));
  Img[9]:=tex.Load(PChar('Bullet.tga'));
  Img[10]:=tex.Load(PChar('pus.tga'));
  Img[11]:=tex.Load(PChar('Cannon.tga'));
  Img[12]:=tex.Load(PChar('Tower2.tga'));
  Img[13]:=tex.Load(PChar('Flame.tga'));
  Img[14]:=tex.Load(PChar('Spark.tga'));
  Img[99]:=tex.Load(PChar('Arrow.tga'));
  Img[98]:=tex.Load(PChar('Back.bmp'));
  {-=Init Font=-}
  Fnt[0]:=ogl.Font.Create(PChar('Comic Sans ms'),16);
  {-=Init Scenes=-}
  GSys:=TGameScene.Init;
  GBac:=TBackupScene.Init;
  {-=Select ActiveScene=-}
  ActivScene:=GSys;
end;

procedure FreeApp;
begin
  GSys.Free; ActivScene:=nil;
end;

end.

