{$WARNINGS OFF}
unit DLevel1;

interface

uses
  DMath,
  DGraph,
  DLevelData,
  DEnemy,
  DCore,
  DMap,
  DGame,
  DWeapon;

//{$DEFINE IsTile: True; Tile: (x:64; y:64) := IsTile: True; Tile: (x:64; y:64)}
//{$DEFINE T128 := IsTile: True; Tile: (x:128; y:128)}

//{$DEFINE CBLACK := Color: (x:0; y:0; z:0; w:1)}

const
  KP1 = 700;
  KP2 = 2000;
  KP3 = 3000;
  KP4 = 5000;

  Name = 'level1';
  Music = 'music0.xm';
  NextLevel = 'level2';
  Heap = 'DATA\textures\TreeWhite.bit';
  //Heap = '';
  Center: TRect = (A:(x: 200; y: 150); B:(x: 440; y:400));
  //Player: TVec2f = (x:KP3; y:300);
  Player: TVec2f = (x:10; y:400);
  Sky1: TVec4f = (x:214/255; y:168/255; z:135/255; w:1.0);
  Sky2: TVec4f = (x:205/255; y:41/255;  z:77/255;  w:1.0);

  L2B = 'DATA\Tiles\Lines2Brown.tga';
  //Black: TVec4f = (x:0; y:0; z:0; w:1);
  //IsTile: True; Tile: (x:64; y:64): TVec2f = (x:64; y:64);

  Blocks: array[0..1-1] of TBlockData = (
      (Tex:L2B; Rect:(A:(x:-10e+6; y:-10e+6);B:(x:-10e+6; y:-10e+6)); IsTile: True; Tile: (x:64; y:64);
        Blend:bmNo; Color: (x:0; y:0; z:0; w:1); Speed: 0){,
       (Tex:L2B; Rect:(A:(x:90; y:320);B:(x:380; y:520)); IsTile: True; Tile: (x:64; y:64);
        Blend:bmNo; CBLACK; Speed: 0), 
       (Tex:L2B; Rect:(A:(x:0; y:450);B:(x:640; y:520)); IsTile: True; Tile: (x:64; y:64);
        Blend:bmNo; CBLACK; Speed: 0), 
       (Tex:L2B; Rect:(A:(x:320; y:400);B:(x:640; y:520)); IsTile: True; Tile: (x:64; y:64);
        Blend:bmNo; CBLACK; Speed: 0), 

       (Tex:L2B; Rect:(A:(x:700; y:420);B:(x:1000; y:520)); IsTile: True; Tile: (x:64; y:64);
        Blend:bmNo; CBLACK; Speed: 1.0; Pos2: (x: 700; y: 40))}
  );

  Entries: array[0..5-1] of TEntryData = (
      (Rect:(A:(x:KP3; y:-1000);B:(x:KP3+300; y:200)); Name: 'epic';
        _Type:etJump2Pattern; Pattern:164),
        //(Rect:(A:(x:90-8; y:320-128);B:(x:90+128; y:320)); Name: 'DATA\textures\TreeWhite.bit'; _Type:etTex),

        (Rect:(A:(x:KP2+400; y:40);B:(x:KP2+528; y:168)); Name: 'DATA\textures\CycleKoh.bit'; _Type:etTex; Blend: bmAlpha), //  , KP2
        (Rect:(A:(x:KP2+90; y:320-128);B:(x:KP2+90+128; y:320)); Name: 'DATA\textures\LowTree.bit'; _Type:etTex; Blend: bmAlpha), // KP2, 
        (Rect:(A:(x:KP2+90; y:320-32);B:(x:KP2+90+32; y:320)); Name: 'DATA\textures\wheel.bit'; _Type:etTex; Blend: bmAlpha), // Lab
        (Rect:(A:(x:KP1+250-64; y:270-128);B:(x:KP1+250+64; y:270)); Name: 'DATA\textures\HighTree.bit'; _Type:etTex; Blend: bmAlpha)

        {(Rect:(A:(x:300-128; y:60-127);B:(x:300; y:60)); Name: 'DATA\textures\Bush.bit'; _Type:etTex),
        (Rect:(A:(x:300+128; y:60-127);B:(x:300+2*128; y:60)); Name: 'DATA\textures\Plant.bit'; _Type:etTex),
        (Rect:(A:(x:300+2*128; y:60-127);B:(x:300+3*128; y:60)); Name: 'DATA\textures\WeedRect.bit'; _Type:etTex),
        (Rect:(A:(x:300+3*128; y:60-127);B:(x:300+4*128; y:60)); Name: 'DATA\fonts\FixedSys.bit'; _Type:etTex)}

        //(Rect:(A:(x:0; y:0);B:(x:640; y:480)); Name: ''; _Type:etTag; Tag: 'respawn1')
        //(Rect:(A:(x:0; y:0);B:(x:640; y:480)); Name: 'respawn1'; _Type:etRespawn)
    ); 

// :   -  !      .
procedure Load;

implementation

function HighTree(X, Y: Single): TEntry;
begin
  Result := TEntryTexture.Create(Game.Map, 'DATA\textures\HighTree.bit', Rect(Vec2f(X, Y), Vec2f(X+128, Y+128)), bmAlpha, Vec4f(0.6, 0.9, 0.6, 1.0)); 
end;

function Tree(X, Y: Single): TEntry;
begin
  Result := TEntryTexture.Create(Game.Map, 'DATA\textures\TreeWhite.bit', Rect(Vec2f(X, Y), Vec2f(X+128, Y+128)), bmAlpha, Vec4f(0.6, 0.9, 0.6, 1.0)); 
end;

function LowTree(X, Y: Single): TEntry;
begin
  Result := TEntryTexture.Create(Game.Map, 'DATA\textures\LowTree.bit', Rect(Vec2f(X, Y), Vec2f(X+128, Y+128)), bmAlpha, Vec4f(0.6, 0.9, 0.6, 1.0)); 
end;

function Block1(X1, Y1, X2, Y2: Single): TBlock;
begin
  with Result do begin
    Tex := Core.Graph.LoadTex(L2B);
    Rect := DMath.Rect(Vec2f(X1, Y1), Vec2f(X2, Y2));
    Tile := Vec2f(64, 64);
    Blend := bmNo;
    Color := Vec4f(0.5, 1, 0, 1);
    Speed := 0;
  end;
end;

function Lift(X1, Y1, X2, Y2: Single; Finish: TVec2f): TBlock;
begin
  with Result do begin
    Tex := Core.Graph.LoadTex('DATA\Tiles\CellCross1.tga');
    Rect := DMath.Rect(Vec2f(X1, Y1), Vec2f(X2, Y2));
    Tile := Vec2f(64, 64);
    Blend := bmDiffuse;
    Color := Vec4f(0.5, 1, 0, 1);
    Speed := 240/(Y1 - Finish.Y);
    Pos1 := Vec2f(X1, Y1);
    Pos2 := Finish;
  end;
end;

procedure AddWeapon(X, Y: Single; W: CWeapon);
  var
    Item: TWeaponItem;
begin
  Item := TWeaponItem.Create(W);
  Item.Pos := Vec2f(X, Y);
  Game.AddItem(Item);
end;

procedure Load;
begin
  Game.Map.AddEntry(TSimpleRespawn.Create(Rect(Vec2f(KP1, -100),
                                               Vec2f(KP1+1000, -90)), 
                                               900)); // KP1

  Game.Map.AddEntry(Tree(-128, 180-128)); // 0
  Game.Map.AddEntry(HighTree(KP1+250-64, 270-128)); // KP1
  Game.Map.AddEntry(Tree(KP1+100-64, 350-128)); // 1 
  Game.Map.AddEntry(LowTree(KP2+90, 320-128)); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 120), Vec2f(1, 1),
                    Vec4f(0.8, 0.4, 0.8, 1), '')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 152), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), '. : 1')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 184), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), '. : 2')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 216), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), 'Help: 3')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP2+300, 120), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), ':')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 120), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), '')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 152), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), ' ;)')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 184), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1),  '  ')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 216), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1),  '.')); // KP2
  Game.Map.AddEntry(TEntrySave.Create(Game.Map, KP2+400, 40, 'saved01'));
  Game.Map.AddEntry(TEntrySave.Create(Game.Map, KP3+1000-128, -128, 'saved02'));
  Game.Map.AddEntry(TEntryJump2Pattern.Create(Game.Map, 'epic', Rect(Vec2f(KP3, -1000), Vec2f(KP3+300, 200)), 162));
  Game.Map.AddEntry(TEntryRespawnRect.Create('respG', Vec2f(KP3+1500, -36),
                                             Vec2f(-15, 0),
                                             20, 1));
  Game.Map.AddEntry(TEntryTag.Create(Game.Map, 'respGtag', 
                                     Rect(Vec2f(KP3+600, -400), Vec2f(KP3+1050, 530)),
                                     'respG'));
  Game.Map.AddEntry(TEntryMusic.Create('DATA\music\boss0.xm', 
                                   Rect(Vec2f(KP3+1060, -1000), 
                                        Vec2f(10000, 1000))));
  Game.Map.AddEntry(TEntryBossDoj.Create(Game.Map, 'boss', 
                                         Rect(Vec2f(KP3+1500, -500),
                                              Vec2f(KP3+1500, -500))));
  Game.Map.AddEntry(TEntryTag.Create(Game.Map, 'bosstag', 
                                     Rect(Vec2f(KP3+1060, -1000), 
                                          Vec2f(10000, 1000)),
                                     'boss'));
  Game.Map.AddBlock(Block1(KP2+300,   20,  KP2+600, 520)); // 2  
  Game.Map.AddBlock(Block1(KP2+500,   220, KP2+550, 260)); // 2 
  Game.Map.AddBlock(Block1(KP1+100,   270, KP1+400, 520)); // 1    
  Game.Map.AddBlock(Block1(KP1+600,   270, KP1+900, 520)); // 1 
  AddWeapon(KP1+860, 270-10, TShotGun);
  AddWeapon(KP3-30, 350, TShotGun);
  AddWeapon(KP4-150, 320, TSimpleWeapon);
  Game.Map.AddBlock(Block1(KP2+90,    320, KP2+380, 520)); // 2  
  Game.Map.AddBlock(Lift  (KP3,       280, KP3+4*64, 280+1.5*64, Vec2f(KP3, 40))); // 3 
  Game.Map.AddBlock(Block1(KP3-60,    370, KP3,     450)); // 3  
  Game.Map.AddBlock(Block1(0,         450, 10000,   520)); // 
  Game.Map.AddBlock(Block1(KP1,       350, KP1+200, 520)); // 1 
  Game.Map.AddBlock(Block1(KP2+320,   400, KP2+640, 520));
  Game.Map.AddBlock(Block1(-640,      180, 0,       520));
  Game.Map.AddBlock(Block1(250,       400, 350,     460));
  //Game.Map.AddBlock(Block1(KP3+300, -250, KP3+1000, -80));
  Game.Map.AddBlock(Block1(KP3+300,   0,  KP3+1000, 520));
  Game.Map.AddBlock(Block1(KP4-300,    340, KP4,     550)); // 4  
  Game.Map.AddBlock(Block1(KP4+300,    -300, KP4+600, 550)); // 4 
  Game.Map.AddBlock(Lift  (KP4, 280, KP4+4*64, 280+1.5*64, Vec2f(KP4, -140)));
  Game.Map.AddEntry(TEntryTexture.Create(Game.Map, 'DATA\textures\Lab.bit', Rect(Vec2f(KP3+500,   20), Vec2f(KP3+500+256,   20+256)), bmAlpha, Vec4f(0.8, 0.4, 0.0, 1.0)));
end;

end.
