unit DLevelData;

interface

uses
  DMath,
  DGraph;

type
TBlockData = record
  Tex: String;
  Rect: TRect;
  IsTile: Boolean;
  Tile: TVec2f;
  Blend: TBlendMode;
  Color: TVec4f;
  Speed: Single;
  Pos2: TVec2f;
end;

TEntryType = (etTex, etJump2Pattern, etTag, etRespawn);

TEntryData = record
  Rect: TRect;
  Name: String;
  _Type: TEntryType;
  Tag: String;
  //Enemy: CEnemy;
  Count: Integer;
  Interval: Single;
  Once: Boolean;
  case TEntryType of
    etTex: (Blend: TBLendMode);
    etJump2Pattern: (Pattern: Integer);
end;

TProc = procedure;

TLevelData = record
  Name: String;
  Music: String;
  NextLevel: String;
  Heap: String;
  Center: TRect;
  Player: TVec2f;
  Sky1, Sky2: TVec4f; //  -  , 
  Blocks: Array of TBlockData;
  Entries: array of TEntryData;
  Load: TProc;
end;

function MakeLevel(Name, Music, NextLevel, Heap: String;
                   Center: TRect;
                   Player: TVec2f;
                   Sky1, Sky2: TVec4f;
                   Blocks: Array Of TBlockData;
                   Entries: array of TEntryData;
                   Load: TProc): TLevelData;

implementation

function MakeLevel;
  var
    I: Integer;
begin
  Result.Name := Name;
  Result.Music := 'DATA\music\' + Music;
  Result.NextLevel := NextLevel;
  Result.Heap := Heap;
  Result.Center := Center;
  Result.Player := Player;
  Result.Sky1 := Sky1;
  Result.Sky2 := Sky2;
  SetLength(Result.Blocks, Length(Blocks));
  for I := 0 to High(Blocks) do
    Result.Blocks[I] := Blocks[I];
  SetLength(Result.Entries, Length(Entries));
  for I := 0 to High(Entries) do
    Result.Entries[I] := Entries[I];
  Result.Load := Load;
end;

end.
