unit e_level1;

interface

procedure StageUpdate(count : single);
procedure ScriptSkip(full : boolean);
procedure RenderBack;
procedure RenderFront;

const NAME = 'welcome'; 

implementation

uses OpenGL, e_global, e_models, e_textures, e_game, e_types, e_camera, e_utils, e_sound, e_particles,
     e_towers, e_lines, e_main, e_enemies;

var
  tower1  : TTower;
  object1, object2 : TObject;
  enemy1, enemy2   : TEnemy;
  hints : array[1..4] of TLabel;
  back_shift : single = 0;

const
  TIME_WAIT_TEXT = 1.5;
  TIME_WAIT_ENEMY = 4;

procedure ScriptUpdate(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0 : begin
        b := true;

        hints[1] := game.AddLabel('hello', 0, 3, 8, false);
        hints[1].Show;
        hints[2] := game.AddLabel('hope, you can fly', 0, 3, 5, false);
        hints[3] := game.AddLabel('', 0, 2, 5, false);
        hints[4] := game.AddLabel('', 0, 2, 5, false);

        SetLength(game.objects, 20);
        
        object1 := AddObject(-6.5,  10, 0, 13, 2, texture_object4);
        object2 := AddObject(6.5,  10, 0, 13, 2, texture_object4);
        AddObject(-14, 0, 0, 2, 22, texture_object4);
        AddObject( 14, 0, 0, 2, 22, texture_object4);
        AddObject(0, -10, 0, 26, 2, texture_object4);


        CountObjects;
      end;
  1 : b := Wait(TIME_WAIT_TEXT);
  2 : begin
        hints[1].Hide;
        hints[2].Show;
        b := Wait(TIME_WAIT_TEXT);
      end;
  3 : begin
        hints[1].size := 5;
        hints[1].text := 'it''s quite simple, actually';
        hints[3].text := 'use ^2a/d^0 or ^2left/right arrows^0 to control';
        hints[1].Show;
        hints[2].Hide;
        hints[3].Show;
        b := Wait(TIME_WAIT_TEXT * 2);
      end;
  4 : begin
        hints[2].text := 'and ^2w/s^0 or ^2up/down arrows^0 to change speed';
        hints[1].Hide;
        hints[2].Show;
        hints[3].Hide;
        b := Wait(TIME_WAIT_TEXT * 2);
      end;
  5 : begin
        hints[4].text := '^2come here';
        hints[4].pos := GetPoint(-sign(game.player.pos.x) * 7, -sign(game.player.pos.y) * 7);
        hints[4].Show;
        hints[2].Hide;
        b := true;
      end;
  6 : b := CollideCircles(hints[4].pos, game.player.pos, 4);
  7 : begin
        hints[1].text := 'good!';
        hints[1].Show;
        hints[4].Hide;
        b := Wait(TIME_WAIT_TEXT);
      end;
  8 : begin
        hints[4].text := '^1it''s enemy:';
        hints[4].pos := GetPoint(3, -sign(game.player.pos.y) * 7.5);
        hints[1].Hide;
        hints[4].Show;
        with hints[4].pos do
          enemy1 := AddEnemy(1, GetPoint(x + 3.2, y - 0.1));
        b := true;
      end;
  9 : b := Wait(TIME_WAIT_ENEMY);
  10: begin
        hints[3].text := '^1and there one more';
        hints[3].pos := GetPoint(-3, -sign(hints[4].pos.y) * 7.5);
        hints[3].Show;
        with hints[3].pos do
          enemy2 := AddEnemy(2, GetPoint(x - 5, y - 0.1));
        b := true;
      end;
  11: b := Wait(TIME_WAIT_TEXT);
  12: begin
        hints[1].text := 'have fun';
        hints[1].Show;
        hints[3].Hide;
        hints[4].Hide;
        b := true;
      end;
  13: b := Wait(TIME_WAIT_ENEMY * 2);
  14: begin
        hints[2].text := 'all right, you''re hero and great pilot';
        hints[1].Hide;
        hints[2].Show;  
        enemy1.dead := true;
        enemy2.dead := true;        
        b := true;
      end;
  15: b := Wait(TIME_WAIT_TEXT * 2);
  16: begin
        hints[1].text := 'welcome!';
        hints[1].pos.x := 0;
        hints[1].pos.y := 0;
        hints[1].Show;
        hints[2].Hide;
        b := Wait(TIME_WAIT_TEXT);
      end;
  17: begin
        hints[3].text := 'and beware of gate';
        hints[3].pos.x := 0;
        hints[3].pos.y := 2;
        hints[3].Show;
        object1.Animate(-12, 4.5, -90, 2.4, 2.5);
        object2.Animate( 12, 4.5,  90, 2.4, 2.5);
        b := true;
      end;
  18: b := player.pos.y > 12;
  19: begin
        GameOver(true);
        exit;
      end;
end;

if b then
  inc(game.script);
end;

procedure ScriptSkip(full : boolean);
begin
end;

procedure StageUpdate(count : single);
var
p : TPoint;
s : single;
begin
ScriptUpdate(count);

clear_color := GetColor(0.3, 0.3, 0.3, 1);

back_shift := back_shift + count * 0.0001;
if back_shift > 1 then
  back_shift := back_shift - 1;
end;

procedure RenderBack;
begin
SetTexture(texture_back1);
glPushMatrix;
glScalef(30, 22, 1);

glColor4f(1, 1, 1, 0.5);
ScaleTexture(30 / 5, 22 / 5);
glCallList(model_quad);
UnScaleTexture;

glBlendFunc(GL_SRC_ALPHA, GL_ONE);
glColor4f(0, 0.7, 0.8, 0.5);
TranslateTexture(back_shift, 0);
ScaleTexture(30 / 5, 22 / 5);
glCallList(model_quad);
UnScaleTexture;
UnTranslateTexture;
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

glPopMatrix;
end;

procedure RenderFront;
begin
end;

end.

