unit e_level6;

interface

procedure StageUpdate(count : single);
procedure ScriptSkip(full : boolean);
procedure RenderBack;
procedure RenderFront;

const NAME = 'escape'; 

implementation

uses OpenGL, e_global, e_models, e_textures, e_game, e_types, e_camera, e_utils,
     e_sound, e_particles, e_main, e_lines, e_enemies;

var
  _objects : array[0..4] of TObject;
  _enemies : array[1..6] of TEnemy;

procedure ScriptUpdate(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0 : begin
        b := true;

        bonuses_active := true;

        AddEnemy(3, GetPoint(-12, 0)).visible := 30;
        AddEnemy(3, GetPoint(0,  27)).visible := 30;
        AddEnemy(3, GetPoint(12, 54)).visible := 30;
        AddEnemy(3, GetPoint(-12, 70)).visible := 30;
        AddEnemy(3, GetPoint(12,  70)).visible := 30;

        _enemies[1] := AddEnemy(2, GetPoint(-8, 8));
        _enemies[1].visible := 20;
        _enemies[2] := AddEnemy(2, GetPoint(8, 23));
        _enemies[2].visible := 20;

        _enemies[3] := AddEnemy(1, GetPoint(6, 24));
        _enemies[3].visible := 20;
        _enemies[4] := AddEnemy(1, GetPoint(-6, 24));
        _enemies[4].visible := 20;
        _enemies[5] := AddEnemy(1, GetPoint(6, 24));
        _enemies[5].visible := 30;
        _enemies[6] := AddEnemy(1, GetPoint(-6, 24));
        _enemies[6].visible := 30;

        SetLength(game.objects, 20);
        AddObject(-14, -22, 0, 2, 22, texture_object3);
        AddObject( 14, -22, 0, 2, 22, texture_object3);

        AddObject(-14, 0, 0, 2, 22, texture_object3);
        AddObject( 14, 0, 0, 2, 22, texture_object3);

        AddObject(-14, 22, 0, 2, 22, texture_object3);
        AddObject( 14, 22, 0, 2, 22, texture_object3);

        AddObject(-14, 44, 0, 2, 22, texture_object3);
        AddObject( 14, 44, 0, 2, 22, texture_object3);
        
        AddObject(-14, 66, 0, 2, 22, texture_object3);
        AddObject( 14, 66, 0, 2, 22, texture_object3);

        _objects[1] := AddObject(-8, 10, 0, 10, 2, texture_object3);
        _objects[1].Animate(8, 10, 0, 2, 1, true);
        _objects[2] := AddObject( 8, 25, 0, 10, 2, texture_object3);
        _objects[2].Animate(-8, 25, 0, 2, 1, true);

        _objects[3] := AddObject(6, 45, 0, 5, 2, texture_object3);
        _objects[3].AnimateRotation(2);
        _objects[4] := AddObject(-6, 45, 0, 5, 2, texture_object3);
        _objects[4].AnimateRotation(-2);

        AddObject(0, 65, 0, 2, 10, texture_object3).AnimateRotation(3);
        AddObject(0, 65, 0, 2, 10, texture_object3).AnimateRotation(-3);

        player.pos.y := -15;
        _objects[0] := AddObject(0, -25, 0, 26, 2, texture_object3);
        _objects[0].Animate(0, 54 + 22, 0, 3, 1);
        CountObjects;
      end;
  1 : b := _objects[0].pos.y > 53.9 + 22;
  2 : begin
        bonuses_active := true;
        b := camera.eye.y > 73 + 22;
      end;
  3 : begin
        GameOver(true);
        exit;
      end;
end;

if b then
  inc(game.script);
end;

procedure StageUpdate(count : single);
var
p : TPoint;
c3, s3, c4, s4 : single;
begin
ScriptUpdate(count);

if game.player.health <= 0 then
   _objects[0].animation_speed := 0;

if game.script = 1 then
  camera.eye.y := _objects[0].pos.y + 11
else
  Aspire(camera.eye.y, 74 + 22, _objects[0].animate_speed_pos * count * 0.001);
  
camera.target.y := camera.eye.y;

_enemies[1].pos.x := _objects[1].pos.x;
_enemies[2].pos.x := _objects[2].pos.x;

c3 := 4 * cos(_objects[3].angle / 180 * pi);
s3 := 4 * sin(_objects[3].angle / 180 * pi);
c4 := 4 * cos(_objects[4].angle / 180 * pi);
s4 := 4 * sin(_objects[4].angle / 180 * pi);
_enemies[3].pos.x := _objects[3].pos.x + c3;
_enemies[3].pos.y := _objects[3].pos.y + s3;
_enemies[4].pos.x := _objects[4].pos.x - c4;
_enemies[4].pos.y := _objects[4].pos.y - s4;
_enemies[5].pos.x := _objects[3].pos.x - c3;
_enemies[5].pos.y := _objects[3].pos.y - s3;
_enemies[6].pos.x := _objects[4].pos.x + c4;
_enemies[6].pos.y := _objects[4].pos.y + s4;

clear_color := GetColor(0.3, 0, 0, 1);
end;

procedure ScriptSkip(full : boolean);
begin
if game.script = 0 then
  ScriptUpdate(0);
end;

procedure RenderBack;
begin
SetTexture(texture_back1);
glPushMatrix;
with camera.eye do glTranslatef(x, y, 0);
glScalef(30, 22, 1);

glColor4f(1, 0, 0, 1);
RotateTexture(10);
ScaleTexture(30 / 10, 22 / 5);
glCallList(model_quad);
UnScaleTexture;
UnRotateTexture;

glBlendFunc(GL_SRC_ALPHA, GL_ONE);
glColor4f(1, 0.5, 0.5, 1);
RotateTexture(-20);
ScaleTexture(-30 / 10, 22 / 5);
glCallList(model_quad);
UnScaleTexture;
UnRotateTexture;
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

glPopMatrix;
end;

procedure RenderFront;
begin

end;

end.

