#include <object.h>
#include <core.h>

#include <hge.h>
#include <hgeresource.h>
#include <hgesprite.h>
#include <hgefont.h>
#include <hgeparticle.h>
#include <Box2D.h>

CHandle::CHandle(HGE *Hge ,b2World *MyWorld, CGameObjectManager *MyObjectManager, CGameInfo *MyGameInfo) : CGameObject(Hge,MyWorld,MyObjectManager,MyGameInfo) {	
	speed = 1500.0f;
	Color = 0x00ffffff;
	Alpha = 0xff000000;

	BodyInfo = new CBodyInfo;
	BodyInfo->Team = 1;
	BodyInfo->isCollide = false;

	b2BodyDef bodyDef;	
	b2CircleDef ShapeDef;

	// 
	// 
	bodyDef.linearDamping = 1.5f;
	bodyDef.angularDamping = 1.5f;
	for(int i = 0; i<8; i++)
	{
		bodyDef.position.Set(40.0f, 30.8f+i*1.2f);
		bodyDef.isBullet = true;
		bodyHandle[i] = World->CreateBody(&bodyDef);
		ShapeDef.radius = 0.8f;
		ShapeDef.density = 1.0f;
		ShapeDef.filter.groupIndex = -1;
		ShapeDef.userData = BodyInfo;
		ShapeDef.localPosition.Set(0.f,0.f);
		shapeHandle[i] = bodyHandle[i]->CreateShape(&ShapeDef);
		bodyHandle[i]->SetMassFromShapes();
	}

	b2RevoluteJointDef jointDef;
	for(int i = 0; i<7; i++)
	{
		jointDef.body1 = bodyHandle[i];
		jointDef.body2 = bodyHandle[i+1];
		jointDef.enableMotor = true;
		jointDef.localAnchor1.Set(0.f,0.6f);
		jointDef.localAnchor2.Set(0.f,-0.6f);
		joint[i] = (b2Joint*)World->CreateJoint(&jointDef);
	}
	bodyHead = bodyHandle[0];
	bodyEnd = bodyHandle[7];
}

CHandle::~CHandle(void) {
	//delete sprPar;
	delete sprBody;
	//hge->Texture_Free(texPar);
	hge->Texture_Free(texBody);
	for(int i = 0; i<8; i++) World->DestroyBody(bodyHandle[i]);
	//hge->Effect_Free(snd);
	hge=0;
}

bool CHandle::Init(void) {
		//sndSelect = hge->Effect_Load("data/sound/select.wav");
		texBody = hge->Texture_Load("data/graphics/handle.png");
		if(!texBody)
		{
			MessageBox(NULL, "Can't load #1", "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
			hge->System_Shutdown();
			hge->Release();
			return false;
		}

		sprBody = new hgeSprite(texBody, 0, 0, hge->Texture_GetWidth(texBody), hge->Texture_GetHeight(texBody));
		sprBody->SetColor(0xFF55ccff);
		sprBody->SetHotSpot(hge->Texture_GetWidth(texBody)/2.f,hge->Texture_GetHeight(texBody)/2.f);
	return true;
}

void CHandle::Update(float delta) {
	
}

void CHandle::Render(void) {
	for (int i = 0; i< 8; i++)
	{
		b2Vec2 pos = bodyHandle[i]->GetPosition();
		float32 ang = bodyHandle[i]->GetAngle();
		pos.operator *=(GAME_GLOBAL_SIZE);
		sprBody->SetColor(0x00555555+Alpha);
		sprBody->RenderEx(pos.x+3,pos.y+3,ang,0.5f);
		sprBody->SetColor(Color+Alpha);
		sprBody->RenderEx(pos.x,pos.y,ang,0.5f);
	}
}