#include <object.h>
#include <hge.h>
#include <algorithm>

CGameInfo::CGameInfo(void) 
{
	isGameOver = false;
	Score = 0;
};

CGameObject::CGameObject(HGE *Hge, b2World *MyWorld, CGameObjectManager *MyObjectManager, CGameInfo *MyGameInfo) 
{
	hge = Hge;
	World = MyWorld;
	ObjectManager = MyObjectManager;
	GameInfo = MyGameInfo;
};

CGameObject::~CGameObject(void) 
{
	hge = 0;
	World = 0;
	ObjectManager = 0;
	GameInfo = 0;
}

void CGameObject::Joing(b2Body* b1,b2Body* b2,b2Vec2 anchor1,b2Vec2 anchor2) {
	b2RevoluteJointDef jointDef;
	jointDef.body1 = b1;
	jointDef.body2 = b2;
	jointDef.localAnchor1.Set(anchor1.x,anchor1.y);
	jointDef.localAnchor2.Set(anchor2.x,anchor2.y); 
	jointBase = (b2Joint*)World->CreateJoint(&jointDef);
}

CGameObjectManager::CGameObjectManager(CCore *MyEngine, HGE *Hge, b2World *MyWorld) 
{
	hge = Hge;
	Engine = MyEngine;
	World = MyWorld;

	Count = 0;
	ZeroMemory(Objects, 4 * LEVELOBJECT_MAX);
	DeleteAllObject();
};

CGameObjectManager::~CGameObjectManager(void) {
	DeleteAllObject();
	hge = 0;
	Engine = 0;
	World = 0;
}

/*void CGameObjectManager::ContactPointDelete(b2Body* body) 
{
	int j = 0; 
	while (j < Engine->m_pointCount)
	{
		ContactPoint* point = Engine->m_points + j;
		if ((point->shape1) && (point->shape2))
		{
			b2Body* b1 = point->shape1->GetBody();
			b2Body* b2 = point->shape1->GetBody();
			if ((b1)&&(b2)&&((b1==body)||(b2==body))) //point->state = e_contactRemoved;
			{
				Engine->m_points[j] = Engine->m_points[Engine->m_pointCount-1];
				Engine->m_pointCount--;
				continue;
			}
		} else
			{
				Engine->m_points[j] = Engine->m_points[Engine->m_pointCount-1];
				Engine->m_pointCount--;
				continue;
			}
		
		j++;	
	}
}*/

void CGameObjectManager::Update(float delta) 
{	
	for(int i = 0; i < LEVELOBJECT_MAX; i++)
		if (Objects[i]!=0) Objects[i]->Update(delta);				

	int j = 0; 
	while (j < Engine->m_pointCount)
	{
		
		ContactPoint* point = Engine->m_points + j;
		//point->velocity.Normalize();
		//if (point->velocity.Length()>1.0f)
		//{
		b2Body* b = point->shape1->GetBody();
		b2Body* b2 = point->shape1->GetBody();
		CBodyInfo *tmp1 = (CBodyInfo*)point->shape1->GetUserData();
		CBodyInfo *tmp2 = (CBodyInfo*)point->shape2->GetUserData();
		if (tmp1 && tmp2)
		{
			//   
			if (((tmp1->Team==2)||(tmp2->Team==2))&&((tmp1->Team==3)||(tmp2->Team==3)))
			{
				tmp1->isCollide = true;
				tmp2->isCollide = true;
			}
			//   
			if (((tmp1->Team==2)||(tmp2->Team==2))&&((tmp1->Team==4)||(tmp2->Team==4)))
			{
				tmp1->isCollide = true;
				tmp2->isCollide = true;
			}
			//   
			if (((tmp1->Team==0)||(tmp2->Team==0))&&((tmp1->Team==3)||(tmp2->Team==3)))
			{
				tmp1->isCollide = true; 
				tmp2->isCollide = true;
			}
		}

		j++;
	}
	DeleteDeadObject();
}

void CGameObjectManager::Render(void) 
{
	int i;
	for(i = 0; i < LEVELOBJECT_MAX; i++) {
		if(Objects[i]) Objects[i]->Render();
	}
}

void CGameObjectManager::DeleteDeadObject(void) 
{
	int i;
	for(i = 0; i < LEVELOBJECT_MAX; i++) {
		if (Objects[i]&&!Objects[i]->isAlive) 
		{
			delete Objects[i];
			Objects[i] = 0;
			Count -= 1;
			return;
		}
	}
}

void CGameObjectManager::DeleteAllObject(void) 
{
	int i;
	for(i = 0; i < LEVELOBJECT_MAX; i++) {
		if(Objects[i]) delete Objects[i];
		Objects[i] = 0;
	}
	Count = 0;
}

int CGameObjectManager::AddObject(CGameObject *obj) 
{
	for(int i = 0; i < LEVELOBJECT_MAX; i++) {
		if(!Objects[i]) {
			Objects[i] = obj;
			Objects[i]->Init();
			Count += 1;
			return i;
		}
	}
	return -1;
}

void CGameObjectManager::Remove(CGameObject *obj) 
{
	if(!obj) return;
	for(int i = 0; i < LEVELOBJECT_MAX; i++) {
		if(Objects[i] == obj) {
			delete Objects[i];
			Objects[i] = 0;
			Count -= 1;
			return;
		}
	}
}