#include "ParticlesEffects.h"



PFExplosion :: PFExplosion ( vec2 & pos, float size ): ParticlesEmitter ( vec2(0.0f), vec3 ( 1.0f, 1.0f, 1.0f ) )
{
	loop = false;
	back = false;
	alpha = true;
	tex = tex_explosion;

	Particle part;
	part.pos = pos;
	part.speed = vec2 ( 0.0f, 0.0f );
	part.life = frand ( 5.0f ) + 30.0f;
	part.start_life = 35.0f;
	part.angle = 0.0f;
	part.angle_speed = 0.0f;
	part.size = vec2 ( frand ()*2.0f + size );

	particles.add(part);
}

void PFExplosion :: UpdateParticle(int i, float dt)
{}

// ------------------------------------------------------------------

PFRocketExplosion :: PFRocketExplosion ( vec2 & pos ): ParticlesEmitter ( vec2(0.0f), vec3 ( 1.0f, 1.0f, 1.0f ) )
{
	loop = false;
	back = false;
	alpha = true;
	tex = tex_rocket;


	for ( int i = 0; i < 5; i++ )
	{
		Particle part;
		part.pos = pos;
		part.speed = vec2 ( frand () - 0.5f, frand () - 0.5f ) * 2.0f;
		part.life = frand ( 30.0f ) + 15.0f;
		part.start_life = 20;
		part.angle = frand(360);
		part.angle_speed = ( frand () - 0.5f ) * 10.0f;
		part.size = vec2 ( frand ()*4.0f + 8.0f, frand ()*4.0f + 8.0f );

		particles.add(part);
	}
}

void PFRocketExplosion :: UpdateParticle(int i, float dt)
{
	particles [i].pos += particles [i].speed * dt;
	particles [i].angle += particles [i].angle_speed * dt;
}

// ------------------------------------------------------------------

PFBulletExplosion :: PFBulletExplosion ( vec2 & pos ): ParticlesEmitter ( vec2(0.0f), vec3 ( 1.0f, 1.0f, 1.0f ) )
{
	loop = false;
	back = false;
	alpha = true;
	tex = tex_bullet;


	for ( int i = 0; i < 5; i++ )
	{
		Particle part;
		part.pos = pos;
		part.speed = vec2 ( frand () - 0.5f, frand () - 0.5f ) * 2.0f;
		part.life = frand ( 30.0f ) + 15.0f;
		part.start_life = 20;
		part.angle = frand(360);
		part.angle_speed = ( frand () - 0.5f ) * 10.0f;
		part.size = vec2 ( frand ()*4.0f + 10.0f, frand ()*4.0f + 10.0f );

		particles.add(part);
	}
}

void PFBulletExplosion :: UpdateParticle(int i, float dt)
{
	particles [i].pos += particles [i].speed * dt;
	particles [i].angle += particles [i].angle_speed * dt;
}

// ------------------------------------------------------------------

PFEnemyExplosion :: PFEnemyExplosion ( vec2 & pos ): ParticlesEmitter ( vec2(0.0f), vec3 ( 1.0f, 1.0f, 1.0f ) )
{
	loop = false;
	back = false;
	alpha = true;
	tex = tex_splinter;

	for ( int i = 0; i < 5; i++ )
	{
		Particle part;
		part.pos = pos;
		part.speed = vec2 ( frand () - 0.5f, frand () - 0.5f ) * 2.0f;
		part.life = frand ( 30.0f ) + 15.0f;
		part.start_life = 20;
		part.angle = frand(360);
		part.angle_speed = ( frand () - 0.5f ) * 10.0f;
		part.size = vec2 ( frand ()*4.0f + 10.0f, frand ()*4.0f + 10.0f );

		particles.add(part);
	}
}

void PFEnemyExplosion :: UpdateParticle(int i, float dt)
{
	particles [i].pos += particles [i].speed * dt;
	particles [i].angle += particles [i].angle_speed * dt;
}

// ------------------------------------------------------------------

PFShock :: PFShock ( vec2 & pos ): ParticlesEmitter ( vec2(0.0f), vec3 ( 1.0f, 1.0f, 1.0f ) )
{
	loop = true;
	back = false;
	alpha = true;
	angle = frand ( 360.0f );
	this->pos = pos;
	anim.init ( vec2 ( 32.0f ), tex_electroshock, 64, 64, 4, 1, 32, 32);
}

void PFShock :: Update(float dt)
{
	anim.update ( dt );
	if ( anim.getActive () == false )
		active = false;
}

void PFShock :: Render ()
{
	glColor4f ( 0.48f, 0.86f, 1.0f, 1.0f );
	anim.render ( pos, angle );
	glColor4f ( 1.0f, 1.0f, 1.0f, 1.0f );
}

// ------------------------------------------------------------------

PFRocketSmoke :: PFRocketSmoke (): ParticlesEmitter ( vec2(0.0f), vec3 ( 1.0f, 1.0f, 1.0f ) )
{
	loop = false;
	back = true;
	alpha = true;
	tex = tex_point;
}

void PFRocketSmoke :: Update(float dt)
{
	for (unsigned int i=0; i<particles.getCount(); i++)
	{
		if (particles[i].life > 0.0f)
		{
			particles[i].life -= dt;
			UpdateParticle(i, dt);
		}
	}
}

void PFRocketSmoke :: addParticle ( vec2 & pos, float size, float lifeTime )
{
	Particle part;
	part.pos = pos;
	part.speed = vec2 ( frand () - 0.5f, frand () - 0.5f );
	part.life = frand ( 2.0f ) + lifeTime * 0.9f;
	part.start_life = lifeTime;
	part.angle = frand(360);
	part.angle_speed = ( frand () - 0.5f ) * 10.0f;
	part.size = vec2 ( size + frand () );

	particles.add(part);
}
