#ifndef __PARTICLES_EFFECTS_H__
#define __PARTICLES_EFFECTS_H__


#include "../Utils/ParticleSystem.h"
#include "../Utils/SpriteAnimation.h"
#include "Resources.h"



class PFExplosion: public ParticlesEmitter
{
public:
	PFExplosion ( vec2 & pos, float size );
	void UpdateParticle(int i, float dt);
};

/*
 ***************************************************************************
 */

class PFRocketExplosion: public ParticlesEmitter
{
public:
	PFRocketExplosion ( vec2 & pos );
	void UpdateParticle(int i, float dt);
};

/*
 ***************************************************************************
 */

class PFBulletExplosion: public ParticlesEmitter
{
public:
	PFBulletExplosion ( vec2 & pos );
	void UpdateParticle(int i, float dt);
};

/*
 ***************************************************************************
 */

class PFEnemyExplosion: public ParticlesEmitter
{
public:
	PFEnemyExplosion ( vec2 & pos );
	void UpdateParticle(int i, float dt);
};

/*
 ***************************************************************************
 */

class PFShock: public ParticlesEmitter
{
public:
	Animation anim;
	float angle;

public:
	PFShock ( vec2 & pos );
	void Update(float dt);
	void Render();
};

/*
 ***************************************************************************
 */

class PFRocketSmoke: public ParticlesEmitter
{
public:
	Animation anim;
	float angle;

public:
	PFRocketSmoke ();
	void Update(float dt);
	void addParticle ( vec2 & pos, float size, float lifeTime  );
};

#endif

