#include	<stdio.h>
#include	<fcntl.h>
#include	<io.h>
#include	<memory.h>
#include	"Data.h"

Data :: Data ( const void * ptr, int len )
{
	bits   = (unsigned char *) ptr;
	length = len;
	pos    = 0;
}

Data :: Data ( const char * fileName )
{
												// make a fix for windows to replace '/' in file path
												// to windoze style '\\' if under windoze
	char * name = strdup ( fileName );

	char * ptr;

	while ( ( ptr = strchr ( name, '/' ) ) != NULL )
		*ptr = '\\';

	bits   = NULL;
	length = 0;
	pos    = 0;
	file   = name;

	int	fd = open ( name, O_RDONLY | O_BINARY );

	free ( name );

	if ( fd == -1 )
		return;

	long	len = filelength ( fd );

	if ( len == -1 )
	{
		close ( fd );

		return;
	}

	bits = (unsigned char *) malloc ( len );

	if ( bits == NULL )
	{
		close ( fd );

		return;
	}

	length = read ( fd, bits, len );

	close ( fd );
}

bool	Data :: isOk () const
{
	return bits != NULL;
}

void * Data :: getPtr ( int offs ) const
{
	if ( offs < 0 || offs >= length )
		return NULL;

	return bits + offs;
}

int	Data :: getBytes ( void * ptr, int len )
{
	if ( pos >= length )
		return -1;

	if ( pos + len > length )
		len = length - pos;

	memcpy ( ptr, bits + pos, len );

	pos += len;

	return len;
}

bool	Data ::  getString ( String& str, char term )
{
	if ( pos >= length )
		return false;

	str = "";

	while ( pos < length && bits [pos] != term )
		str.append( ( const char * ) ( &bits [pos++] ), 1 );

	if ( pos < length && bits [pos] == term )
		pos ++;
													// skin OA part of line terminator (0D,0A)
	if ( term == '\r' && pos + 1 < length && bits [pos+1] == '\n' )
		pos++;

	return true;
}
