/***********************************************************************
bmp, dds, tga, jpeg, jpg, png
************************************************************************/


#ifndef __TEXTURE_MANAGER_H__
#define __TEXTURE_MANAGER_H__

#include <map>

#include "../Utils/String.h"
#include "../Utils/Array.h"

using namespace std;

class Texture;
class TextureLoader;
class Data;

									// cache entity
struct TextureInfo
{
	unsigned int id;
	String fileName;
	unsigned int refCount;
};

									// texture manager
class TextureManager
{
public:
	TextureManager () {}
	~TextureManager () {}

	unsigned int createTexture1D ( bool mipmap, const char * fileName );
	unsigned int createTexture2D ( bool mipmap, const char * fileName );

	bool deleteTexture ( unsigned int ID );

private:
	map <String, TextureLoader *> decoders;
	Array <TextureInfo *> cache;

	void initManager ();
	bool addDecoder ( const char * ext, TextureLoader * decoder );

	Texture * getTexture ( const char * fileName );
	bool loadTexture ( int target, bool mipmap, const char * fileName );

													// cache functions
	TextureInfo* findTexture ( unsigned int ID, unsigned int &index );
	TextureInfo* findTexture ( const String &fileName, unsigned int &index );
};

extern TextureManager textureManager;

#endif

